from car_util import * # yeahhh don't do this


############
# Front wheel section
############

def front_pts(t):

    wheel_well_offs = 0.14

    base = []
    for j, _wd in enumerate([-wpoints[-2], -wpoints[2],
                             wpoints[2], wpoints[-2]]):
        p = []
        base.append(p)
        fl = copy(front_fwd)
        fl.reverse()
        for i, d in enumerate(fl):
            wd = _wd
            if j in [1,2] and i != 3:
                if j == 1: wd += 0.04
                if j == 2: wd -= 0.04
            if (i == 1 or i == 3) and (j == 0 or j == 3):
                continue
            if i == 1:
                d -= 0.14
            if i == 2:
                if j == 0 or j == 3:
                    # move front bumper into curve (wheel well)
                    d -= wheel_well_offs
            if i == 0:
                if j == 0 or j == 3:
                    # rear of wheel well
                    d += wheel_well_offs * 0.3
                else:
                    d -= wheel_well_offs * 0.7
            height = h0
            # adjust back to match floor left/right
            if i == 0 and j in [0,3]:
                height += 0.06
            # adjust front bottom line to scoop air up
            if i == len(fl)-1:
                height -= 0.03
            if i == len(fl)-2 and j in [0,3]:
                height -= 0.04
            pos = [wd, d, height]
            p.append(pos)
            t.add_joint(pos)

    return base


class Front(Group):
    def __init__(self):
        Group.__init__(self, name="front")
        self.dflt_pipe_diam = dthin

    def make(self, bonnetpts):
        bbase, bscoop = bonnetpts
        base = front_pts(self)

        # horizontal pipes, front-wise
        for i in [1, 2]:
            p = base[i]
            for j in range(len(p)-1):
                self.add_pipe(p[j], p[j+1], dthick)

        # horizontal pipes, width-wise
        for j in range(len(p)):
            self.add_pipe(base[1][j], base[2][j], dthick)

        self.add_pipe(base[0][0], base[1][0], dthick, AUTO, jleft)
        self.add_pipe(base[2][0], base[3][0], dthick, jright, AUTO)
        # and at front bumper
        self.add_pipe(base[0][1], base[1][2], dthick, AUTO, jleft)
        self.add_pipe(base[0][1], base[1][3], dthick, AUTO, jleft)
        self.add_pipe(base[3][1], base[2][2], dthick, AUTO, jright)
        self.add_pipe(base[3][1], base[2][3], dthick, AUTO, jright)

        # horizontal pipes, diagonal-width-wise
        for j in range(len(p)-1):
            self.add_pipe(base[1][j], base[2][j+1], dthin)

        # connecting struts to bonnet: very front
        self.add_pipe(base[3][1], bbase[2][3], dthick)
        self.add_pipe(base[0][1], bbase[1][3], dthick)

        self.add_pipe(base[0][1], bbase[0][2], dthick, AUTO, jdown)
        self.add_pipe(base[1][2], bbase[0][2], dthin)
        self.add_pipe(base[3][1], bbase[3][2], dthick, AUTO, jdown)
        self.add_pipe(base[2][2], bbase[3][2], dthin)

        # centre-box struts
        for i in range(len(p)):
            offs1 = jup
            if i == len(p)-1:
                diam = dthick
                offs2 = jdown
            else:
                diam = dthin
                offs2 = jdown0
            self.add_pipe(base[1][i], bbase[2][i], diam)
            self.add_pipe(base[1][i], bbase[1][i], diam)
            self.add_pipe(base[2][i], bbase[2][i], diam)

        # centre-box diagonals
        for i in range(len(p)-1):
            self.add_pipe(base[2][i], bbase[1][i+1], dthin, jul)
            self.add_pipe(base[1][i], bbase[1][i+1], dthin)
            self.add_pipe(base[2][i], bbase[2][i+1], dthin)

        #return base, self
        # rear struts to bonnet
        self.add_pipe(base[0][0], bbase[0][0], dthick)
        self.add_pipe(base[-1][0], bbase[-1][0], dthick)
        self.add_pipe(base[0][0], bbase[0][1], dthin)
        self.add_pipe(base[-1][0], bbase[-1][1], dthin)

        self.add_pipe(base[1][0], bbase[0][1], dthin, jlf)
        self.add_pipe(base[-2][0], bbase[-1][1], dthin, jrf)

        self.add_pipe(base[1][0], bbase[0][0], dthin)
        self.add_pipe(base[-2][0], bbase[-1][0], dthin)

        return base, self

